# Setting
$serviceExecutablePath = "[ConMasフォルダパス]\IRService\IReporterService.exe"

$serviceName = "IRIWService"
$logFile = "$PSScriptRoot" + "\IRServiceInstall.log"
# WriteLog
function Write-Log {
    param (
        [string]$Message,
        [string]$LogLevel = "INFO"
    )
    
    $timestamp = (Get-Date).ToString("yyyy-MM-dd HH:mm:ss")
    
    $logMessage = "$timestamp [$LogLevel] $Message"
    
    Add-Content -Path $logFile -Value $logMessage
    Write-Host $logMessage
}

# Administrator
If (!([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole("Administrators")) { Start-Process powershell.exe "-File `"$PSCommandPath`"" -Verb RunAs; exit }

try {
    # Check Service Exsist
    $service = Get-Service -Name $serviceName -ErrorAction SilentlyContinue

    if ($service) {
        # UnInstall
        Write-Log -Message "Exsist Service" -LogLevel "INFO"
        Write-Log -Message "Service UnInstall Start" -LogLevel "INFO"
        # Service Stop
        Stop-Service -Name $serviceName -Force
        
        # Delete Service
        sc.exe delete $serviceName
        Write-Log -Message "Service UnInstall End" -LogLevel "INFO"
    } else {
        Write-Log -Message "Not Exsist Service" -LogLevel "INFO"
    }

    # Install
    Write-Log -Message "Service Install Start" -LogLevel "INFO"

    New-Service -Name $serviceName -Binary $serviceExecutablePath -StartupType Automatic

    Write-Log -Message "Service Install End" -LogLevel "INFO"

    Start-Service -Name $serviceName
    Write-Log -Message "Service Start" -LogLevel "INFO"
    Write-Log -Message "Success" -LogLevel "INFO"
}
catch {
    Write-Log -Message "Error:" + $error[0] -LogLevel "INFO"
}
